"use strict"

function Event (map, message, choices) {
   var that = this;

   // Link to map.
   map.events.push (that);
   that.map = map;

   // Functions.
   that.Run = function (choice) {
      if (that.choices == null) {
         that.done = true;
         return;
      }
      else if (typeof that.choices == "function") {
         that.choices (that);
         that.done = true;
         return;
      }
      if (choice == null)
         return;

      if (choice in that.choices) {
         that.choices[choice] (that);
         that.done = true;
         return;
      }
      else {
         console.error ("Invalid choice '" + choice + "'.");
         return;
      }
   };
   that.IsDone = function () {
      return done;
   };
   that.KeyDown = function (key) {
      var game = that.map.game;
      if (that.done) {
         if (key != 32)
            return;
         if (game.eventMsgs.length - game.eventMsgMax <= 0) {
            game.state = "playing";
            game.event = null;
            game.eventMsgs = [];
            return;
         }
         else {
            game.SpliceMessages ();
            game.DrawScene ();
         }
      }
      else {
         // Moving left/right.
         if (key == 37 || key == 39) {
            var nextIndex = 0;
            var maxIndex = that.choices.length;
            if (key == 37)
               nextIndex = (that.selected.index + maxIndex - 1) % maxIndex;
            else if (key == 39)
               nextIndex = (that.selected.index + maxIndex + 1) % maxIndex;
            that.selected = that.choices[nextIndex];
            game.DrawScene ();
         }
         else if (key == 32) {
            that.done = true;
            game.eventMsgs = [];
            game.eventMsgMax = 0;
            that.selected.func (that);
            game.DrawScene ();
         }
      }
   };

   // Initialize.
   that.message = message;
   that.done    = false;
   if (typeof choices == "function")
      that.choices = choices;
   else if (typeof choices == "object") {
      that.choices = [];
      for (var c in choices) {
         var choice = choices[c];
         new EventChoice (that, choice.name, choice.func);
      }
   }
}
