"use strict"

function ImageSet (name) {
   var that = this;

   // Functions.
   that.GetRandom = function() {
      return that.images[RandomInt (0, that.count)];
   }
   that.GetImage = function (index) {
      if (!(index in that.images))
         return null;
      return that.images[index];
   }

   // Initialization.
   that.name = name;
   that.images = [];

   // Look for images of format 'img_<name>_<index>'.
   that.count = 0;
   for (var i = 0; i < 256; i++) {
      // Attempt to get the DOM element. Bail if not found.
      var id = "img_" + name + "_" + (i + 1);
      var element = document.getElementById (id);
      if (element == null)
         break;

      // Load the image.
      new ImageSetImage (that, element);
      that.count++;
   }

   // Complain if nothing was loaded.
   if (that.count == 0) {
      console.error ("No images for image set '" + name + "'.");
      return;
   }

   // Add to the global image set list.
   gImageSets[name] = that;
}

function GetImageSet (name) {
   if (!(name in gImageSets))
      return null;
   return gImageSets[name];
}
