"use strict"

function ImageSetImage (imageSet, element)
{
   var that = this;

   // Functions.
   that.GetWidth = function () {
      return that.element.width;
   }
   that.GetHeight = function () {
      return that.element.height;
   }
   that.Draw = function (x, y, scale, options) {
      // Default scale and options.
      if (scale == null)
         scale = 1.00;
      if (options == null)
         options = {};

      // Determine X/Y orientation.
      var hAlign = options.hAlign == null ? 0.00 : options.hAlign;
      var vAlign = options.vAlign == null ? 0.00 : options.vAlign;

      // Determine draw positioning.
      var width  = parseInt (that.element.width  * scale);
      var height = parseInt (that.element.height * scale);
      var x = parseInt (x - width  * hAlign);
      var y = parseInt (y - height * vAlign);
      if (options.hFlip == true) x += width;
      if (options.vFlip == true) y += height;

      // Perform translation and flipping.
      oContext.translate (x * gDrawScale, y * gDrawScale);
      if (options.hFlip === true) oContext.scale (-1,  1);
      if (options.vFlip === true) oContext.scale ( 1, -1);

      // Draw!
      oContext.drawImage (that.element, 0, 0,
         width * gDrawScale, height * gDrawScale);

      // Undo flipping and translation.
      if (options.hFlip === true) oContext.scale (-1,  1);
      if (options.vFlip === true) oContext.scale ( 1, -1);
      oContext.translate (-x * gDrawScale, -y * gDrawScale);
   }

   // Initialization.
   that.imageSet = imageSet;
   that.element  = element;
   that.index    = imageSet.images.length;
   imageSet.images[imageSet.images.length] = that;
}
