"use strict"

function Item (player, name, quantity, increment, xOff, yOff, unit, units,
               prefix, desc)
{
   var that = this;

   // Insert into our player's item list.
   that.player = player;
   player.items[name] = that;
   player.GetGame().ItemExistsNow (name);

   // Functions.
   that.DisplayQuantity = function (quantity) {
      if (quantity == null)
         quantity = that.quantity;
      return Math.ceil (quantity).toFixed (0);
   }
   that.DisplayName = function (quantity) {
      var q = that.DisplayQuantity (quantity);
      var unit = that.unit;
      if (q != '1' && that.units != null)
         unit = that.units;
      return q + " " + unit;
   };
   that.Change = function (amount) {
      if (amount == null || amount == 0)
         return;
      that.quantity += amount;
      that.OnChange ();
   };
   that.OnChange = function () {};
   that.Draw = function (x, y, scale, options) {
      if (that.imageSet == null)
         return;
      var index = that.ImageIndex ();
      that.imageSet.images[index].Draw (
         x + that.xOff, y + that.yOff, scale, options);
      oContext.fillStyle = "#cccccc";
      oContext.textAlign = "center";
      oContext.font = (16 * gDrawScale) + "px our-font";
      oContext.fillText (that.prefix + that.DisplayQuantity (),
         (x + that.xOff) * gDrawScale, (y - 16) * gDrawScale);
   };
   that.ImageIndex = function () {
      var i = 0, q = that.quantity;
      while (q > 0.00 && (i + 1) in that.imageSet.images) {
         q -= that.increment;
         i++;
      }
      return i;
   };

   // Initialization.
   that.name      = name;
   that.quantity  = quantity;
   that.increment = increment;
   that.unit      = unit;
   that.units     = units;
   that.imageSet  = !(name in gImageSets) ? null : gImageSets[name];
   that.xOff      = xOff;
   that.yOff      = yOff;
   that.prefix    = (prefix == null) ? "" : prefix;
   that.desc      = desc;
}
