"use strict"

function Map (game, name, image) {
   var that = this;

   // Functions.
   that.Draw = function (x, y) {
      that.image.Draw (x, y);
      for (var l in that.landmarks) {
         var landmark = that.landmarks[l];
         if (landmark == game.player.landmark &&
             parseInt (game.time * 100.00) % 2 == 0)
            continue;
         landmark.image.Draw (
            x + landmark.x,
            y + landmark.y, 1.00, {
               hAlign: 0.50,
               vAlign: 0.50,
            });
      }
      gImageSets["mini"].images[0].Draw (
         x + that.game.player.x,
         y + that.game.player.y, 1.00, {
            hAlign: 0.50,
            vAlign: 0.75,
         });
   };
   that.LastLandmark = function () {
      return (that.landmarks == null || that.landmarks.length == 0)
         ? 0
         : that.landmarks[that.landmarks.length - 1];
   };

   // Link to our game.
   that.game = game;
   game.maps[name] = that;

   // Initialization.
   that.name      = name;
   that.image     = image;
   that.landmarks = [];
   that.waypoints = [];
   that.events    = [];
}
