"use strict"

function Sprite (layer) {
   var that = this;

   // Functions.
   that.Tick = function (hours, speed) {
      if (that.layer.options.noScroll !== true)
         that.Scroll (hours, speed);
      if (that.animate > 0.00 && (that.alwaysAnimate || speed > 0.00)) {
         that.aniTime -= hours;
         while (that.aniTime <= 0.00) {
            that.aniTime += that.animate;
            that.index = (that.index + 1) % that.layer.imageSet.images.length;
            that.SetImage ();
         }
      }
   };
   that.Scroll = function (hours, speed) {
      that.x -= hours * (speed + that.speed) * Math.pow (2.00, that.z);
      if (that.x + that.image.GetWidth() <= 0.00) {
         var index = that.layer.sprites.indexOf (that);
         that.layer.sprites.splice (index, 1);
      }
   };
   that.Draw = function (x, y) {
      if (that.onlyIf != null && !(that.onlyIf ()))
         return false;
      that.image.Draw (x + that.x, y + 128, 1.00, {
         vAlign: 1.00,
         hFlip:  that.flip,
      });
      return true;
   };
   that.SetImage = function () {
      that.image = imageSet.GetImage (that.index);
   };

   // Link to layer.
   that.layer = layer;
   layer.sprites.push (that);

   // Get the image from our image set.
   var imageSet = layer.GetImageSet ();
   that.index = layer.GetIndex ();
   that.SetImage ();

   // Initialize.
   that.x       = layer.xNext;
   that.z       = RandomFloat (layer.options.zMin, layer.options.zMax);
   that.speed   = RandomFloat (layer.options.speedMin, layer.options.speedMax);
   that.flip    = layer.options.hFlip;
   that.animate = layer.options.animate;
   that.aniTime = that.animate;
   that.onlyIf  = layer.options.onlyIf;
   that.alwaysAnimate = layer.options.alwaysAnimate;

   // Update our layer.
   layer.xNext += that.image.GetWidth() + layer.RandomGap ();
   layer.NewIndex ();
}
