"use strict"

function Stat (player, name, color, value, gameOverMsg) {
   var that = this;

   // Add to player.
   that.player = player;
   player.stats[name] = that;
   player.GetGame().StatExistsNow (name);

   // Functions.
   that.Change = function (amount) {
      if (amount == null || amount == 0)
         return;
      that.value += amount;
      if (that.value < 0.00) {
         that.player.game.GameOver (that.gameOverMsg);
         that.value = 0.00;
      }
      if (that.value > 100.00)
         that.value = 100.00;
      that.OnChange ();
   };
   that.OnChange = function () {};
   that.DisplayName = function () {
      var cap = that.name.charAt(0).toUpperCase() +
                that.name.slice(1);
      return cap + ": " + that.value.toFixed(0) + "%";
   };
   that.Draw = function (x, y) {
      oContext.fillStyle = that.color;
      var fill = parseInt (Math.ceil (that.value) / 100.00 * 101.00);
      oContext.fillRect (
         x * gDrawScale, y * gDrawScale,
         fill * gDrawScale, 8 * gDrawScale);
   }

   // Initialize.
   that.name        = name;
   that.color       = color;
   that.value       = value;
   that.gameOverMsg = gameOverMsg;
}
